﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using sl_Chart_ticket_503895.Models;
using System.Collections.ObjectModel;
using Telerik.Windows.Data;
using System.Collections;
using Telerik.Windows.Controls.Charting;
using System.Collections.Generic;
using Telerik.Windows.Controls.GridView;
using System.Threading;
using System.Windows.Threading;
using System.Linq;

namespace sl_Chart_ticket_503895.ViewModels
{
    public class ViewModelProducts : ViewModelBase
    {
        public ViewModelProducts()
        {
            this.Products = new ObservableCollection<Product>() 
            { 
                new Product{ ProductId = 1, Manufacturer = "telerik", YearManufactured = 2010, Value = 20, },
                new Product{ ProductId = 2, Manufacturer = "telerik", YearManufactured = 2011, Value = 200, },
                new Product{ ProductId = 3, Manufacturer = "telerik", YearManufactured = 2012, Value = 140, }, 
                
                new Product{ ProductId = 4, Manufacturer = "microsoft", YearManufactured = 2010, Value = 120, },
                new Product{ ProductId = 5, Manufacturer = "microsoft", YearManufactured = 2011, Value = 10, },
                new Product{ ProductId = 6, Manufacturer = "microsoft", YearManufactured = 2012, Value = 70, },
                
                new Product{ ProductId = 7, Manufacturer = "silverlight", YearManufactured = 2010, Value = 140, },
                new Product{ ProductId = 8, Manufacturer = "silverlight", YearManufactured = 2012, Value = 130, },
                
                new Product{ ProductId = 9, Manufacturer = "wpf", YearManufactured = 2011, Value = 110, },
                new Product{ ProductId = 10, Manufacturer = "wpf", YearManufactured = 2012, Value = 160, },
                new Product{ ProductId = 11, Manufacturer = "wpf", YearManufactured = 2012, Value = 160, },
                new Product{ ProductId = 12, Manufacturer = "wpf", YearManufactured = 2012, Value = 120, },
            };

            this.CollectionView = new QueryableCollectionView(this.Products);
            this.CollectionView.GroupDescriptors.CollectionChanged += this.CollectionView_GroupDescriptorsChanged;
            this.CollectionView.FilterDescriptors.CollectionChanged += this.FilterDescriptors_CollectionChanged;

            this.UpdateSeriesMappings();
        }

        public ObservableCollection<Product> Products
        {
            get; 
            private set;
        }

        private SeriesMappingCollection seriesMappings;
        public SeriesMappingCollection SeriesMappings
        {
            get { return this.seriesMappings; }
            set
            {
                if (this.seriesMappings != value)
                {
                    this.seriesMappings = value;
                    this.OnPropertyChanged("SeriesMappings");
                }
            }
        }
        
        public QueryableCollectionView CollectionView
        {
            get;
            private set;
        }
        
        void CollectionView_GroupDescriptorsChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            this.UpdateSeriesMappings();
        }

        void FilterDescriptors_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            this.UpdateSeriesMappings();
        }

        private void UpdateSeriesMappings()
        {
            SeriesMapping mapping1 = new SeriesMapping();
            mapping1.SeriesDefinition = new BarSeriesDefinition(); 

            if (this.CollectionView.GroupDescriptors.Count == 0)
            {
                mapping1.ItemMappings.Add(new ItemMapping(Product.ValuePropertyName, DataPointMember.YValue));
            }
            else
            {
                ChartAggregateFunction aggFunct = (ChartAggregateFunction)Enum.Parse(typeof(ChartAggregateFunction), AggregateFunctions.Sum, true);
                mapping1.ItemMappings.Add(new ItemMapping(Product.ValuePropertyName, DataPointMember.YValue, aggFunct));
            }

            if (this.CollectionView.GroupDescriptors.Count > 1)
            {
                IGroupDescriptor lastGroupDescriptor = this.CollectionView.GroupDescriptors[this.CollectionView.GroupDescriptors.Count - 1];
                mapping1.ItemMappings.Add(new ItemMapping(this.GetDataMemberName(lastGroupDescriptor), DataPointMember.XCategory));
            }

            foreach (IGroupDescriptor descriptor in this.CollectionView.GroupDescriptors)
            {
                mapping1.GroupingSettings.GroupDescriptors.Add(new ChartGroupDescriptor(this.GetDataMemberName(descriptor)));
            }

            if (this.CollectionView.FilterDescriptors.Count > 0)
            {
                foreach (var filter in this.CollectionView.FilterDescriptors)
                {
                    mapping1.FilterDescriptors.Add(new ChartFilterDescriptor(filter));
                }
            }

            SeriesMappingCollection mappings = new SeriesMappingCollection();
            mappings.Add(mapping1);
            this.SeriesMappings = mappings;
        }

        private string GetDataMemberName(IGroupDescriptor descriptor)
        {
            if (descriptor is GroupDescriptor)
                return (descriptor as GroupDescriptor).Member;

            if (descriptor is ColumnGroupDescriptor)
            {
                GridViewDataColumn column = ((ColumnGroupDescriptor)descriptor).Column as GridViewDataColumn;
                return column.GetDataMemberName();
            }

            return null;
        }
    }
}
